app/main/routes.py
# uncompyle6 version 3.2.3
# Python bytecode 2.7 (62211)
# Decompiled from: Python 2.7.15rc1 (default, Apr 15 2018, 21:51:34)
# [GCC 7.3.0]
# Embedded file name: /run/user/1000/gvfs/smb-share:server=dibro-elite.local,share=pycharmprojects/lesho-construction/app/main/routes.py
# Compiled at: 2018-09-11 17:46:42
from datetime import datetime
from flask import render_template, flash, redirect, abort, url_for, request, g, jsonify, current_app
from flask_login import current_user, login_required, logout_user
from flask_uploads import UploadSet, configure_uploads, IMAGES
from app import db
from flask import Blueprint
from app.models import *
from app.main.forms import *
from xkcdpass import xkcd_password as xp
import os, random, string
from app.auth.email import send_user_added_email
from sqlalchemy import or_
main = Blueprint('main', __name__)
photos = UploadSet('photos', IMAGES)


@main.before_app_request
def before_request():
    if current_user.is_authenticated:
        if current_user.status == False:
            logout_user()
            flash('You are not activated please contact the administrator','danger')
            return redirect(url_for('auth.login'))
        current_user.last_seen = datetime.utcnow()
        db.session.commit()
    g.search_form = SearchForm()
    g.company = Company.query.first()
    g.images = Theme.query.first()
    car=Vehicle.query.first()
    if car is None:
        file_name = 'cars.csv'
        data = Vehicle.Load_Vehicle_Data(file_name)
        for i in data:
            record = Vehicle(**{
                'make' : i[0],
                'model' : i[1]
                })
            db.session.add(record)
        db.session.commit()
    year=Year.query.first()
    if year is None:
        file_name = 'years.csv'
        data = Year.Load_Year_Data(file_name)
        for i in data:
            record = Year(**{
                'year' : i[1]
            })
            db.session.add(record)
        db.session.commit()
@main.route('/add_property_features/<id>', methods=['GET', 'POST'])
@login_required
def add_property_features(id):
    if current_user.role.permissions.create_property != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    if request.method == 'POST':
        property = Property.query.filter_by(id=id).first_or_404()
        feature = PropertyFeature(feature_icon=request.form['feature_icon'], feature_name=request.form['feature_name'],
                                  property=property)
        db.session.add(feature)
        db.session.commit()
        return jsonify({'status': 1, 'message': 'feature edited successfully'})
    return jsonify(status=0)


@main.route('/', methods=['GET', 'POST'])
@login_required
def index():
    inventory_count = Inventory.query.count()
    reserved_count = Inventory.query.filter_by(state='reserved').count()
    sold_count =Inventory.query.filter_by(state='sold').count()
    available_count =Inventory.query.filter_by(state='available').count()
    count_all = {'inventory': inventory_count,'reserved': reserved_count,'sold': sold_count,'available': available_count}
    inventory = Inventory.query.limit(5)
    reserved = Inventory.query.filter_by(state='reserved').limit(5)
    sold = Inventory.query.filter_by(state='sold').limit(5)
    available = Inventory.query.filter_by(state='available').limit(5)
    tables = {'inventorylist': inventory,'reservedlist': reserved,'soldlist': sold,'availablelist': available}
    return render_template('admin/index.html', title='Dashboard',tables=tables, count_all=count_all)


#admin functions
@main.route('/users', methods=['GET', 'POST'])
@login_required
def users():
    if current_user.role.access_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    form = RegistrationForm()
    form.role.choices = [(row.id, row.role) for row in Role.query.order_by(Role.created_at.desc()).all()]
    if form.validate_on_submit():
        role = Role.query.filter_by(id=form.role.data).first_or_404()
        user = User(username=form.username.data, phone_number=form.phone_number.data, role=role, email=form.email.data)
        user.set_password(form.password.data)
        db.session.add(user)
        db.session.commit()
        flash('User added successfully!', 'success')
        return redirect(url_for('main.users'))
    users = User.query.order_by(User.last_seen.desc()).all()
    return render_template('admin/users.html', form=form, users=users)


@main.route('/edit_user/<id>', methods=['GET', 'POST'])
@login_required
def edit_user(id):
    if current_user.role.permissions.write_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    user = User.query.filter_by(id=id).first_or_404()
    form = EditRegistrationForm(obj=user)
    form.role.choices = [(row.id, row.role) for row in Role.query.order_by(Role.created_at.desc()).all()]
    if form.validate_on_submit():
        role = Role.query.filter_by(id=form.role.data).first_or_404()
        user.username = form.username.data
        user.role = role
        user.phone_number = form.phone_number.data
        db.session.commit()
        flash('User edited successfully', 'success')
        return redirect(url_for('main.users'))
    return render_template('admin/edit_user.html', form=form, title='Edit User')


@main.route('/add_role', methods=['GET', 'POST'])
@login_required
def add_role():
    if request.method == 'POST':
        role = Role(role=request.form['role'])
        permission = Permission(role=role)
        db.session.add(role)
        db.session.commit()
    return jsonify({'status': 1})

#edit role
@main.route('/edit_role/<id>', methods=['GET', 'POST'])
@login_required
def edit_role(id):
    role = Role.query.filter_by(id=id).first_or_404()
    if request.method == 'POST':
        role.role = request.form['role']
        db.session.commit()
        return jsonify({'status': 1})
    elif request.method == 'GET':
        data={'role':role.role, 'id':role.id}
        return jsonify({'status': 1, 'data':data})


@main.route('/view_user/<id>')
@login_required
def view_user(id):
    if current_user.role.permissions.read_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    user = User.query.filter_by(id=id).first_or_404()
    return render_template('admin/view_user.html', title='view user', user=user)

@main.route('/activate/<user_id>')
@login_required
def activate(user_id):
    if current_user.role.permissions.write_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    user = User.query.filter_by(id=user_id).first_or_404()
    user.status=True
    db.session.commit()
    flash("user activated!", 'success')
    return redirect(url_for('main.users'))

@main.route('/deactivate/<user_id>')
@login_required
def deactivate(user_id):
    if current_user.role.permissions.write_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    user = User.query.filter_by(id=user_id).first_or_404()
    if user.id == 1 or user==current_user:
        flash("can't deactivate superadmin or yourself", 'danger')
        return redirect(url_for('main.users'))
    user.status=False
    db.session.commit()
    flash("user deactivated!", 'success')
    return redirect(url_for('main.users'))


@main.route('/role_permissions', methods=['GET', 'POST'])
@login_required
def role_permissions():
    if current_user.role.permissions.read_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    roles = Role.query.order_by(Role.created_at.desc()).all()
    return render_template('admin/role_permissions.html', roles=roles, title='Roles & Permission')


@main.route('/role_permissions_values', methods=['GET', 'POST'])
@login_required
def role_permissions_values():
    role = Role.query.order_by(Role.created_at.desc()).first()
    if role is None:
        return jsonify({'status': 0})
    if request.method == 'POST':
        role = Role.query.filter_by(id=request.form['id']).first_or_404()
    response = jsonify({'status': 1, 'data': role.to_dict_role()})
    return response


@main.route('/edit_role_permissions_js', methods=['GET', 'POST'])
@login_required
def edit_role_permissions_js():
    role = Role.query.filter_by(id=request.form['id']).first_or_404()
    data = request.form
    role.from_dict(data)
    role.permissions.from_dict_permissions(data)
    db.session.commit()
    return jsonify({'status': 1})


@main.route('/company_settings', methods=['GET', 'POST'])
@login_required
def company_settings():
    if current_user.role.permissions.read_user != True:
        flash("You don't have access to this module!", 'danger')
        return redirect(url_for('main.index'))
    company = Company.query.first()
    if company is None:
        form = CompanyForm()
        if form.validate_on_submit():
            company = Company(company_name=form.company_name.data, contact_person=form.contact_person.data,
                              phone_number=form.phone_number.data, email=form.email.data, address=form.address.data,
                              country=form.country.data, city=form.city.data, state=form.state.data,
                              postal_code=form.postal_code.data, bank_name=form.bank_name.data,
                              bank_country=form.bank_country.data, bank_address=form.bank_address.data,
                              account_number=form.account_number.data)
            db.session.add(company)
            db.session.commit()
            flash('company settings updated successfully', 'success')
            return redirect(url_for('main.company_settings'))
    else:

app/templates/includes/header-navigation.html
<div class="header">
    <div class="header-left">
        <a href="{{url_for('main.index')}}" class="logo">
<img src="{% if g.images %}{{url_for('static', filename='uploads/{}'.format(g.images.logo))}}{% else %}{{url_for('static',filename='img/logo.png')}}{% endif %}" width="40" height="40" alt="">
</a>
    </div>
    <div class="page-title-box pull-left">
<h3>{% if g.company %}{{ g.company.company_name }}{% else %}Skye Technologies{% endif %}</h3>
    </div>
<a id="mobile_btn" class="mobile_btn pull-left" href="#sidebar"><i class="fa fa-bars" aria-hidden="true"></i></a>
<ul class="nav navbar-nav navbar-right user-menu pull-right">
<li class="dropdown">
<a href="#" class="dropdown-toggle user-link" data-toggle="dropdown" title="{{ current_user.role.role }}">
  <span class="user-img"><img class="img-circle" src="{{url_for('static', filename='img/user.jpg')}}" width="40" alt="{{ current_user.username }}">
  <span class="status online"></span></span>
  <span>{{ current_user.username }}</span>
  <i class="caret"></i>
</a>
<ul class="dropdown-menu">
  <li><a href="{{ url_for('auth.logout') }}">Logout</a></li>
</ul>
</li>
</ul>
<div class="dropdown mobile-user-menu pull-right">
<a href="#" class="dropdown-toggle" data-toggle="dropdown" aria-expanded="false"><i class="fa fa-ellipsis-v"></i></a>
<ul class="dropdown-menu pull-right">
<li><a href="{{ url_for('auth.logout') }}">Logout</a></li>
</ul>
</div>
</div>

app/templates/includes/sidebar-navigation.html
<div class="sidebar" id="sidebar">
    <div class="sidebar-inner slimscroll">
        <div id="sidebar-menu" class="sidebar-menu">
            <ul>
                <li {%- if request.path== url_for('main.index') %} class="active"{% endif %} >
                <a href="{{ url_for('main.index') }}">Dashboard</a>
                </li>
                <li class="submenu">
                  <a href="#"><span>Inventory</span> <span class="menu-arrow"></span></a>
                  <ul class="list-unstyled" style="display: none;">
                    {% if current_user.role.access_inventory == True %}
                    <li >
                    <a {%- if request.path== url_for('main.inventory') or request.path== url_for('main.add_inventory') %} class="active"{% endif %} href="{{ url_for('main.inventory') }}">View Inventory</a>
                    </li>
                    {% endif %}
                    {% if current_user.role.permissions.create_inventory == True %}
                    <li>
                    <a {%- if request.path== url_for('main.add_make') or request.path== url_for('main.make') %} class="active"{% endif %} href="{{ url_for('main.make') }}">View Makes</a>
                    </li>
                    {% endif %}
                 </ul>
               </li>
                {% if current_user.role.access_inventory == True %}
                <li {%- if request.path== url_for('main.sold_cars') %} class="active"{% endif %} >
                <a href="{{ url_for('main.sold_cars') }}">Sold</a>
                </li>
                {% endif %}
                {% if current_user.role.access_inventory == True %}
                <li {%- if request.path== url_for('main.reserved_cars') %} class="active"{% endif %} >
                <a href="{{ url_for('main.reserved_cars') }}">Reserved</a>
                </li>
                {% endif %}

                {% if current_user.role.access_inventory == True %}
                <li {%- if request.path== url_for('main.bazaar') %} class="active"{% endif %} >
                <a href="{{ url_for('main.bazaar') }}">Bazaar</a>
                </li>
                {% endif %}

                {% if current_user.role.access_inventory == True %}
  							<li {%- if request.path == url_for('main.clients') %} class="active"{% endif %}>
  								<a href="{{ url_for('main.clients') }}">Clients</a>
  							</li>
                {% endif %}
                {% if current_user.role.access_inventory == True %}
  							<li {%- if request.path == url_for('main.suppliers')  %} class="active"{% endif %}>
  								<a href="{{ url_for('main.suppliers') }}">Suppliers</a>
  							</li>
                {%endif%}
                {% if current_user.role.access_inventory == True %}
  							<li {%- if request.path == url_for('main.enquiry')  %} class="active"{% endif %}>
  								<a href="{{ url_for('main.enquiry') }}">Enquiries</a>
  							</li>
                {%endif%}
                {% if current_user.role.access_inventory == True %}
  							<li {%- if request.path == url_for('main.imports')  %} class="active"{% endif %}>
  								<a href="{{ url_for('main.imports') }}">Imports</a>
  							</li>
                {%endif%}
                <li class="submenu">
                  <a href="#"><span>Customer requests </span> <span class="menu-arrow"></span></a>
                  <ul class="list-unstyled" style="display: none;">
                    {% if current_user.role.access_inventory == True %}
                  <li><a {%- if request.path == url_for('main.sell_requests') %} class="active"{% endif %} href="{{ url_for('main.sell_requests') }}">Sell car</a></li>
                  {% endif %}
                  {% if current_user.role.access_inventory == True %}
    							<li><a {%- if request.path ==  url_for('main.trade_in') %} class="active"{% endif %} href="{{ url_for('main.trade_in') }}">Trade in</a></li>
                  {% endif %}
                  {% if current_user.role.access_inventory == True %}
    							<li><a {%- if request.path ==  url_for('main.import_requests')  %} class="active"{% endif %} href="{{ url_for('main.import_requests') }}">Imports</a></li>
                  {% endif %}
                  {% if current_user.role.access_inventory == True %}
    							<li><a {%- if request.path ==  url_for('main.contact_us')  %} class="active"{% endif %} href="{{ url_for('main.contact_us') }}">Contact us</a></li>
                  {% endif %}
                 </ul>
               </li>
            <li class="submenu">
              <a href="#"><span> Finance </span> <span class="menu-arrow"></span></a>
              <ul class="list-unstyled" style="display: none;">
                {% if current_user.role.access_inventory == True %}
              <li><a {%- if request.path == url_for('main.quotations') %} class="active"{% endif %} href="{{ url_for('main.quotations') }}">Quotations</a></li>
              {% endif %}
              {% if current_user.role.access_inventory == True %}
							<li><a {%- if request.path ==  url_for('main.invoices') %} class="active"{% endif %} href="{{ url_for('main.invoices') }}">Invoices</a></li>
              {% endif %}
              {% if current_user.role.access_inventory == True %}
							<li><a {%- if request.path ==  url_for('main.payments')  %} class="active"{% endif %} href="{{ url_for('main.payments') }}">Payments</a></li>
              {% endif %}
              {% if current_user.role.access_inventory == True %}
							<li><a {%- if request.path ==  url_for('main.bills')  %} class="active"{% endif %} href="{{ url_for('main.bills') }}">Bills</a></li>
              {% endif %}
             </ul>
           </li>

                <li {%- if request.path == url_for('main.settings')  %} class="active"{% endif %}>
                <a href="{{ url_for('main.settings') }}">Settings</a>
              </li>
                {% if current_user.role.access_user == True %}
              <li class="submenu">
                  <a href="#"><span> Admin </span> <span class="menu-arrow"></span></a>
                  <ul class="list-unstyled" style="display: none;">
                    <li><a {%- if request.path ==  url_for('main.users') %} class="active"{% endif %} href="{{ url_for('main.users') }}">Users</a></li>
                    {% if current_user.role.permissions.read_user == True %}
                    <li><a {%- if request.path ==  url_for('main.role_permissions') %} class="active"{% endif %} href="{{ url_for('main.role_permissions') }}">Role & Permission </a></li>
                    {% endif %}
                    {% if current_user.role.permissions.read_user == True %}
                    <li><a {%- if request.path ==  url_for('main.company_settings') %} class="active"{% endif %} href="{{ url_for('main.company_settings') }}">Company settings </a></li>
                    {% endif %}
                    {% if current_user.role.permissions.read_user == True %}
                    <li><a {%- if request.path ==  url_for('main.theme_settings') %} class="active"{% endif %} href="{{ url_for('main.theme_settings') }}">Theme settings </a></li>
                    {% endif %}
                  </ul>
              </li>
              {% endif %}
            </ul>
        </div>
    </div>
</div>